//-------------------------------------------------------------------
//Copyright (C) 2004 Nick o'DIMM ( nick_o_dimm[at]pochtamt[dot]ru )
//-------------------------------------------------------------------

#include <windows.h>
#include "cheats.h"
#include "Mem_M68k.h"

unsigned char Ram[0x10000];
unsigned int RamBits[0x10000 >> 3];
GensCheatSizes bytes;
GensCheatCompType cmp_type;
int val_type;

int Cheat_Count()
{
	int adr, cnt=0;
	switch (bytes)
	{
	case GC_8_BITS:
		for (adr=0; adr<0x10000; adr++)
			if (RamBits[adr >> 5] & (1 << (adr & 31)))
				cnt++;
		break;
	case GC_16_BITS:
		for (adr=0; adr<0x10000-1; adr+=2)
			if (RamBits[adr >> 5] & (1 << (adr & 31)))
				cnt++;
		break;
	case GC_32_BITS:
		for (adr=0; adr<0x10000-3; adr+=2)
			if (RamBits[adr >> 5] & (1 << (adr & 31)))
				cnt++;
		break;
	}

	return cnt;
}

void Cheat_Reset()
{
	int i;
	memset(&RamBits, -1, sizeof(RamBits));
	for (i=0; i<0x10000; i++)
		Ram[i] = M68K_RB(i+0xFF0000);
}

void SearchCheatsForChange(GensCheatCompType cmp_type)
{
	int sz, step, i, j, flag;
	long cur, prev;

	switch (bytes)
	{
	case GC_8_BITS:
		sz = 0;
		step = 1;
		break;
	case GC_16_BITS:
		sz = 1;
		step = 2;
		break;
	case GC_32_BITS:
		sz = 3;
		step = 2;
		break;
	}

	for (i=0; i<0x10000-sz; i+=step)
	{
		if (RamBits[i >> 5] & (1 << (i & 31))) {
		
			cur = 0; prev = 0;
			for (j=0; j<=bytes; j++)
			{
				cur  += M68K_RB(i+j+0xFF0000) << (8*(bytes-j));
				prev += Ram[i+j] << (8*(bytes-j));
			}

			switch (cmp_type)
			{
			case GC_LESS_THAN:
				flag = cur < prev;
				break;
			case GC_GREATER_THAN:
				flag = cur > prev;
				break;
			case GC_LESS_THAN_OR_EQUAL:
				flag = cur <= prev;
				break;
			case GC_GREATER_THAN_OR_EQUAL:
				flag = cur >= prev;
				break;
			case GC_EQUAL:
				flag = cur == prev;
				break;
			case GC_NOT_EQUAL:
				flag = cur != prev;
				break;
			}

			if (!flag) RamBits[i >> 5] &= ~(1 << (i & 31));
		}
	}
}

void SearchCheatsForValue(GensCheatCompType cmp_type, long value)
{
	int sz, step, i, j, flag;
	long cur;

	switch (bytes)
	{
	case GC_8_BITS:
		sz = 0;
		step = 1;
		break;
	case GC_16_BITS:
		sz = 1;
		step = 2;
		break;
	case GC_32_BITS:
		sz = 3;
		step = 2;
		break;
	}

	for (i=0; i<0x10000-sz; i+=step)
	{
		if (RamBits[i >> 5] & (1 << (i & 31))) {
		
			cur = 0;
			for (j=0; j<=bytes; j++)
				cur  += M68K_RB(i+j+0xFF0000) << (8*(bytes-j));

			switch (cmp_type)
			{
			case GC_LESS_THAN:
				flag = cur < value;
				break;
			case GC_GREATER_THAN:
				flag = cur > value;
				break;
			case GC_LESS_THAN_OR_EQUAL:
				flag = cur <= value;
				break;
			case GC_GREATER_THAN_OR_EQUAL:
				flag = cur >= value;
				break;
			case GC_EQUAL:
				flag = cur == value;
				break;
			case GC_NOT_EQUAL:
				flag = cur != value;
				break;
			}

			if (!flag) RamBits[i >> 5] &= ~(1 << (i & 31));
		}
	}
}
